<template>
  <div class="px-5">
    <v-row justify="center" class="mt-12 grey lighten-3 pa-12">
      <v-col cols="12" class="white">
        <v-card class="card d-flex flex-wrap mx-3" color="primary" dark>
          <v-col class="text-center" cols="12">
            <span class="subtitle-1">
              APPLY FOR LEAVE
            </span>
          </v-col>
        </v-card>
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
        >
          <v-container class="py-0">
            <v-row justify="center">
              <v-col cols="12">
                <v-select
                  :value="leavetype"
                  :items="leave"
                  :rules="leaverule"
                  label="Choose Your Option"
                  item-value="text"
                  @change="$emit('update:leavetype', $event)"
                ></v-select>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="6">
                <v-menu
                  v-model="menu1"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      :value="from"
                      label="From"
                      prepend-icon="mdi-event"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      @change="$emit('update:from', $event)"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    @change="$emit('update:from', $event)"
                    :value="from"
                    @input="menu1 = false">
                  </v-date-picker>
                </v-menu>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="6">
                <v-menu
                  v-model="menu2"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      :value="to"
                      label="To"
                      prepend-icon="mdi-event"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      @change="$emit('update:to', $event)"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    @change="$emit('update:to', $event)"
                    :value="to"
                    @input="menu2 = false">
                  </v-date-picker>
                </v-menu>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12">
                <v-textarea
                  :value="description"
                  label="Description"
                  :rules="descriptionrule"
                  @change="$emit('update:description', $event)"
                >
                </v-textarea>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="8" class="mt-5 text-center">
                <v-btn
                  :disabled="!valid"
                  :loading="loading"
                  color="secoundary"
                  class="ma-2 white--text"
                  @click="submit"
                >
                  APPLY
                </v-btn>
                <v-btn
                  color="warning"
                  class="ma-2"
                  v-on:click="cancel"
                >
                  Cancel
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import { getLeaveTypeList } from '@/firebase/db';

export default {
  data() {
    return {
      valid: true,
      menu1: false,
      menu2: false,
      leave: [],
      descriptionrule: [
        (v) => !!v || 'Descriiption is required',
        (v) => (v && v.length >= 10) || 'Description must be greater than 10 characters',
      ],
      leaverule: [
        (v) => !!v || 'Leave type is required',
      ],
    };
  },
  created() {
    getLeaveTypeList().then((value) => {
      this.leave = value;
    });
  },
  props: {
    leavetype: {
      type: String,
      required: true,
    },
    from: {
      type: String,
      required: true,
    },
    to: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: true,
    },
    loading: {
      type: Boolean,
      required: false,
    },
  },
  methods: {
    submit() {
      if (this.$refs.form.validate()) {
        this.$emit('submit');
      }
    },
    cancel() {
      this.$emit('cancel');
    },
  },

};
</script>

<style scoped>
.card {
  top: -20px;
}
</style>
